<template>
  <div class="datetime-picker">
    <i class="icon-calender md-icon md-icon-font md-icon-image md-date-icon md-theme-default">
      <svg height="24" viewBox="0 0 24 24" width="24" xmlns="http://www.w3.org/2000/svg">
        <path d="M17 12h-5v5h5v-5zM16 1v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2h-1V1h-2zm3 18H5V8h14v11z"></path>
        <path d="M0 0h24v24H0z" fill="none"></path>
      </svg>
    </i>
    <datetime v-model="internalValue"
              :type="type"
              :format="format"
              placeholder="Select date"
              input-class="input-calender"
              :max-datetime="getMaxDatetime()"
              :min-datetime="getMinDatetime()"
              monday-first
              auto-continue
              auto-close
              zone="utc"
              required>
    </datetime>
    <span style="position: absolute; right: 0px; bottom: 20%;">GMT +1</span>
  </div>
</template>

<script>
  import moment from 'moment';
  import bignumber from 'bignumber.js';

  export default {
    inject: ['$validator'],
    data() {
      return  {
        internalValue: '',
      }
    },
    props: {
      value: {
        required: true
      },
      minDatetime: {
        default: null
      },
      maxDatetime: {
        default: null
      },
      format: String,
      inputType: {
        required: true,
        validator: function (value) {
          return ['timestamp',].indexOf(value) !== -1;
        }
      },
      type: {
        validator: function (value) {
          return ['datetime','date', 'time'].indexOf(value) !== -1;
        },
        default: 'datetime'
      }
    },
    watch: {
      value: {
        handler () {
          if (!this.value) {
            this.internalValue = '';
            return;
          }
          const value =  this.formatValue(this.value);
          if (this.internalValue !== value) {
            this.internalValue = `${value}`;
          }
        },
        immediate: true
      },
      internalValue() {
        const time = moment.utc(this.internalValue).utcOffset(-1).format('YYYY-MM-DD HH:mm:ss');
        this.$emit('input', moment.utc(time).valueOf());
      }
    },
    methods: {
      getMaxDatetime() {
        if (!this.maxDatetime) {
          return null;
        }
        return this.formatValue(this.maxDatetime);
      },

      getMinDatetime() {
        if (!this.minDatetime) {
          return null;
        }
        return this.formatValue(this.minDatetime);
      },

      formatValue(value) {
        switch(this.inputType) {
          case 'timestamp':
            if (bignumber(value).isZero()) {
              return '';
            }
            const time = moment(value, 'x').utcOffset(1).format('YYYY-MM-DD HH:mm:ss');
            return moment.utc(time).toISOString();
        }
      }
    }
  }
</script>

<style lang="scss">
  .datetime-picker {
    width: 100%;
    position: relative;
    font-size: 14px;

    .vdatetime-popup__header,
    .vdatetime-popup__date-picker__item--selected > span > span,
    .vdatetime-popup__date-picker__item--selected:hover > span > span {
      background: #ff7100;
    }

    .vdatetime-popup__list-picker__item--selected,
    .vdatetime-popup__actions__button {
      color: #ff7100;
    }
    .vdatetime-calendar__month__day--selected > span > span, .vdatetime-calendar__month__day--selected:hover > span > span {
      color: #fff;
      background: #ff7100 !important;
    }
    .vdatetime-time-picker__item--selected {
      color: #ff7100;
      font-size: 32px;
    }

    .input-calender {
      height: 36px;
      padding: 7px 0;
      font-size: 14px !important;
      -webkit-text-fill-color: #495057 !important;
      display: block;
      -webkit-box-flex: 1;
      flex: 1;
      border: none;
      background: none;
      transition: .4s cubic-bezier(.25,.8,.25,1);
      transition-property: font-size,padding-top,color;
      font-family: inherit;
      line-height: 32px;
      width: 100%;
    }

    .vdatetime {
      position: relative;
      position: relative;
      padding-left: 30px;
    }

    .vdatetime::after {
      background-color: #d2d2d2 !important;
      transition: border .3s cubic-bezier(.4,0,.2,1),opacity .3s cubic-bezier(.4,0,.2,1),transform 0s cubic-bezier(.4,0,.2,1) .3s,-webkit-transform 0s cubic-bezier(.4,0,.2,1) .3s;
      will-change: border,opacity,transform;
      content: " ";
      position: absolute;
      bottom: 0;
      right: 0;
      left: 0;
      z-index: 1;
      height: 1px;
    }
    .icon-calender {
      position: absolute;
      bottom: 20%;
    }
  }
</style>
